@echo off
color 74

pushd "%~dp0"
set RunLoc=%cd%

echo.
echo      _____ __  ______  ____  ________  ______ 
echo     / ___// / / / __ \/ __ \/ ____/  ^|/  /   ^|
echo     \__ \/ / / / /_/ / /_/ / __/ / /^|_/ / /^| ^|
echo    ___/ / /_/ / ____/ _, _/ /___/ /  / / ___ ^|
echo   /____/\____/_/   /_/ ^|_/_____/_/  /_/_/  ^|_^|
echo.  
echo ================================================
echo  BioStar 2.8.12 Auto DB Backup Script Generator
echo ================================================
echo    THIS TOOL IS TESTED WITH 2.7.10 - 2.8.12
echo ================================================
echo   ONLY SUPPORTED FOR USE WITH 2.7.10 - 2.8.12
echo ================================================
echo.
echo. - Please read the HowTo file cautions before proceeding
echo. - This tool will create a script you can use with Task Scheduler
echo. - You can also run the generated script as admin to take a manual backup
echo. 
echo. 

:bit
echo Enter your BioStar bit architecture 
echo 1. 32bit (32 Architecture) (Enter 1 or 3232) 
echo 2. 32bit (64 Architecture) (Enter 2 or 3264)
echo 3. 64bit (64 Architecture) (Enter 3 or 64)
echo.
set /P BIT=
%=%
If /I "%BIT%"=="1" goto thirtytwothirtytwo
If /I "%BIT%"=="2" goto thirtytwo
If /I "%BIT%"=="3" goto sixtyfour
If /I "%BIT%"=="3232" goto thirtytwothirtytwo
If /I "%BIT%"=="3264" goto thirtytwo
If /I "%BIT%"=="64" goto sixtyfour
echo.
echo Incorrect input & goto :bit
echo. 

:thirtytwothirtytwo

echo.
echo Type in the drive letter you installed BioStar 2 (example: c)
set /p UserDrive=
echo.

echo Type in your Database ID (default is 'root') :
set /p UserID=
echo.


powershell -Command $pword = read-host "Enter password" -AsSecureString ; ^
    $BSTR=[System.Runtime.InteropServices.Marshal]::SecureStringToBSTR($pword) ; ^
        [System.Runtime.InteropServices.Marshal]::PtrToStringAuto($BSTR) > .tmp.txt 
set /p UserPW=<.tmp.txt & del .tmp.txt

:enckey3232
echo.
echo       Is EncKey located in default directory?
echo Note: Previous to BioStar 2.8, EncKey will be located in default
echo       Entering Y will use the default location, Entering N will prompt you for a location
SET DefaultDirectory=N
echo.
set /P DefaultDirectory=Default Directory? (Y/[N])?
if /I "%DEFAULTDIRECTORY%" NEQ "Y" GOTO ENCENTRY 

set EncKey="%UserDrive%:\Program Files\BioStar 2\util\enckey"
GOTO BACKUPLOCATION3232

:encentry3232
echo.
echo Type location of Enckey file (E.g. C:\Enckey\enckey):
set /p EncKey=
echo.

:backuplocation3232

echo.
echo To create a folder within where the batch files are kept, Simply enter 'D'
echo Type in the Backup Location : 
set /p WHERE=

IF "%WHERE%" == "%RUNLOC%" (
echo. 
echo Backup location cannot be location of Batch files, Please choose another
echo.
goto backuplocation3232
)

IF /I "%WHERE%"=="D" CALL :DEFAULT_LOCATION

echo.

powershell -Command "(Get-Content Templates\bk_script3232.bat) -replace 'UserID', '%UserID%' | Out-File my_db_backup_script.bat" -encoding ASCII

powershell -Command "(Get-Content my_db_backup_script.bat) -replace 'UserPW', '%UserPW%' | Out-File my_db_backup_script.bat" -encoding ASCII

powershell -Command "(Get-Content my_db_backup_script.bat) -replace 'UserDrive', '%UserDrive%' | Out-File my_db_backup_script.bat" -encoding ASCII

powershell -Command "(Get-Content my_db_backup_script.bat) -replace 'WHERE', '%WHERE%' | Out-File my_db_backup_script.bat" -encoding ASCII

powershell -Command "(Get-Content my_db_backup_script.bat) -replace 'KEYENC', '%EncKey%' | Out-File my_db_backup_script.bat" -encoding ASCII

goto :end


:thirtytwo 
echo.
echo Type in the drive letter you installed BioStar 2 (example: c)
set /p UserDrive=
echo.

echo Type in your Database ID (default is 'root') :
set /p UserID=
echo.


powershell -Command $pword = read-host "Enter password" -AsSecureString ; ^
    $BSTR=[System.Runtime.InteropServices.Marshal]::SecureStringToBSTR($pword) ; ^
        [System.Runtime.InteropServices.Marshal]::PtrToStringAuto($BSTR) > .tmp.txt 
set /p UserPW=<.tmp.txt & del .tmp.txt

:enckey32
echo.
echo       Is EncKey located in default directory?
echo Note: Previous to BioStar 2.8, EncKey will be located in default
echo       Entering Y will use the default location, Entering N will prompt you for a location
SET DefaultDirectory=N
echo.
set /P DefaultDirectory=Default Directory? (Y/[N])?
if /I "%DEFAULTDIRECTORY%" NEQ "Y" GOTO ENCENTRY32 

SET EncKey="%UserDrive%:\Program Files (x86)\BioStar 2\util\enckey"
GOTO BACKUPLOCATION32

:encentry32
echo.
echo Type location of Enckey file :
set /p EncKey=
echo.

:backuplocation32

echo.
echo To create a folder within where the batch files are kept, Simply enter 'D'
echo Type in the Backup Location : 
set /p WHERE=

IF "%WHERE%" == "%RUNLOC%" (
echo. 
echo Backup location cannot be location of Batch files, Please choose another
echo.
goto backuplocation32
)

IF /I "%WHERE%"=="D" CALL :DEFAULT_LOCATION

echo.

powershell -Command "(Get-Content Templates\bk_script3264.bat) -replace 'UserID', '%UserID%' | Out-File my_db_backup_script.bat" -encoding ASCII

powershell -Command "(Get-Content my_db_backup_script.bat) -replace 'UserPW', '%UserPW%' | Out-File my_db_backup_script.bat" -encoding ASCII

powershell -Command "(Get-Content my_db_backup_script.bat) -replace 'UserDrive', '%UserDrive%' | Out-File my_db_backup_script.bat" -encoding ASCII

powershell -Command "(Get-Content my_db_backup_script.bat) -replace 'WHERE', '%WHERE%' | Out-File my_db_backup_script.bat" -encoding ASCII

powershell -Command "(Get-Content my_db_backup_script.bat) -replace 'KEYENC', '%EncKey%' | Out-File my_db_backup_script.bat" -encoding ASCII

goto :end

:sixtyfour
echo.
echo Type in the drive letter you installed BioStar 2 (example: c)
set /p UserDrive=
echo.

echo Type in your Database ID (default is 'root') :
set /p UserID=
echo.

powershell -Command $pword = read-host "Enter password" -AsSecureString ; ^
    $BSTR=[System.Runtime.InteropServices.Marshal]::SecureStringToBSTR($pword) ; ^
        [System.Runtime.InteropServices.Marshal]::PtrToStringAuto($BSTR) > .tmp.txt 
set /p UserPW=<.tmp.txt & del .tmp.txt

:enckey64

echo.
echo       Is EncKey located in default directory?
echo Note: Previous to BioStar 2.8, EncKey will be located in default
echo       Entering Y will use the default location, Entering N will prompt you for a location
SET DefaultDirectory=N
echo.
set /P DefaultDirectory=Default Directory? (Y/[N])?
if /I "%DEFAULTDIRECTORY%" NEQ "Y" GOTO ENCENTRY64 

set EncKey="%UserDrive%:\Program Files\BioStar 2(x64)\util\enckey"
GOTO BACKUPLOCATION64

:encentry64
echo.
echo Type location of Enckey file :
set /p EncKey=
echo.

:backuplocation64

echo.
echo To create a folder within where the batch files are kept, Simply enter 'D'
echo Type in the Backup Location : 
set /p WHERE=

IF "%WHERE%" == "%RUNLOC%" (
echo. 
echo Backup location cannot be location of Batch files, Please choose another
echo.
goto backuplocation64
)

IF /I "%WHERE%"=="D" CALL :DEFAULT_LOCATION

echo.

set mypath=%cd%

powershell -Command "(Get-Content Templates\bk_script64.bat) -replace 'UserID', '%UserID%' | Out-File my_db_backup_script.bat" -encoding ASCII

powershell -Command "(Get-Content my_db_backup_script.bat) -replace 'UserPW', '%UserPW%' | Out-File my_db_backup_script.bat"  -encoding ASCII

powershell -Command "(Get-Content my_db_backup_script.bat) -replace 'UserDrive', '%UserDrive%' | Out-File my_db_backup_script.bat"  -encoding ASCII

powershell -Command "(Get-Content my_db_backup_script.bat) -replace 'WHERE', '%WHERE%' | Out-File my_db_backup_script.bat"  -encoding ASCII

powershell -Command "(Get-Content my_db_backup_script.bat) -replace 'KEYENC', '%EncKey%' | Out-File my_db_backup_script.bat" -encoding ASCII

:end 
echo.
echo Your new script file should be in your current folder with this batch file. 
echo The file name is my_db_backup_script.bat
echo. 
PAUSE
exit

:ERROR
echo ERROR... Now Exiting
timeout 6
exit

:DEFAULT_LOCATION
set WHERE=%RUNLOC%\Backup